(
	/*
	-- automaticaly create the necessary REs:VRayBumpNormals (cam), VRayMatteShadow, VRayDiffuseFilter, pPos (World)
	-- gather animation data: expanded frame numbers (i.e.: #(1,3,4,5,7,8,9) and altus interval ranges (i.e.: #(#(1,1),#(3,5),#(7,9))
	-- generate base output file name
	-- generate base REs file names, with the frame number being the ALTUS INTERVAL start
	-- change MC Seed
	-- render img1
	-- generate base output file name
	-- generate base REs file names, with the frame number being the ALTUS INTERVAL start
	-- change MC seed
	-- render img2
	-- build cmdline string PER ALTUS INTERVAL RANGE
	-- execute the denoising
	-- open the denoised image / folder
	*/
	
	global altusRoll
	try (destroyDialog AltusRoll) catch ()
	
	fn checkSetVray = 
	(
		renderSceneDialog.close()
		macros.run "Render" "RenderButtonMenu_Switch_To_Production_Mode"
		renderSceneDialog.commit()
		renderSceneDialog.open()
		if (renderers.current.classID as string == "#(1941615238, 2012806412)") then renderers.current else 
		(
			if (queryBox "Want me to set VRay as your production renderer?") then 
				(
					(renderers.current = (for i in RendererClass.classes where matchPattern (i as string) pattern:"V_Ray_Adv*" do exit with i()) )
					renderers.current
				)
				else messagebox "Don't blame ME if i don't do what you want me to!"
		)
	)

	local cr = checkSetVray()
	local rendBaseName = ""
	local rendPassOne = ""
	local rendPassTwo = ""
	local rendResult = ""
	local reFilePaths = #()

	local altusCommandString = ""				--will contain the Altus command string to put in a batch file
	local fileNamesArray=#()					--will contain the GENERATED RE names PER ALTUS ANIM RANGE (start frame of the range as number?)
	local altusNamesArray=#()					--will contain the GENERATED RE names for the WHOLE SET of ALTUS ANIM RANGES (start frame of the range as number?)
	local animationPickupFrames=#()				--will contain the rendPickupFrames string result (1,3,5-12)
	local expandedAnimationFrames=#()			--Will contain the expanded list of frame numbers, across the whole animation range (for rendering purposes), like #(1,3,5,6,7,8,9,10,11,12)
	local altusAnimRanges=#()					--Will contain sub-arrays of start and end frames, like #(#(1,1),#(3,3),#(5,12))
	local writeMultipleOutputs=false			--Write multiple ALTUS outputs? (possibly deprecated: always do so for animations. perhaps even for stills if they can be treated as single-frame animations)
	local isAnimatedSequence=False				--Deprecated, may be re-exhumed
	
	local doSaveSeeded = false					--Flag to save the max files only
	local fileSeedB0=fileSeedB1=undefined		--Two max file names
	local doBB = false							--Flag to submit to BB
	local bbSuspended = false					--Flag for paused BB submission
	local netMgr=NetRender.GetManager()			--BB Manager

	local filterRadius = 10						--Altus filter size
	local filterFrames = 1						--Altus frames to fliter
	local useGPU = true							--Altus UseGpu
	local oldSplitData=#()						--splitOn,splitRGB,SplitAlpha,SplitFilename,SplitBitmap,rendertype

	fn readOldSplitData =
	(
		oldSplitData[1]=cr.output_splitgbuffer
		oldSplitData[2]=cr.output_splitRGB
		oldSplitData[3]=cr.output_splitAlpha
		oldSplitData[4]=cr.output_splitfilename
		try 
		(
			oldSplitData[5]=cr.output_splitbitmap
		)
		catch 
		(
			oldSplitData[5]=undefined
		)

		oldSplitData
	)

	fn restoreOldSplitData =
	(
		cr.output_splitGbuffer=oldSplitData[1]
		cr.output_splitRGB=oldSplitData[2]
		cr.output_splitAlpha=oldSplitData[3]
		cr.output_splitfilename=oldSplitData[4]
		if oldSplitData[4] != "" do
		(
			if doesFileExist oldSplitData[4] then 
			(
				cr.output_splitbitmap=openBitMap oldSplitData[4]
			)
			else 
			(
				tempBmp=bitmap 1 1 hdr:on filename:oldSplitData[4]
				save tempBmp
				cr.output_splitbitmap=tempBmp
				free tempBmp 
				deleteFile oldSplitData[4]
			)
		)
	)
	
	-- output of type baseimage.reName.frame[0000].ext

	fn submitToBB = 
	(
		isConnected=netMgr.connected
		if not isConnected then
		(
-- 			try 
-- 			(
				if (netMgr.connect #Automatic "255.255.255.0") do print "Auto Connected!"
				submitToBB()
-- 			)
-- 			catch
-- 			(
-- 				messageBox "Please connect to your preferred BackBurner Manager before using the Submit option."
-- 			)
		)
		else
		(
			print "Was Connected!"
			if (netMgr.QueryControl #wait ) do --only take control if you have permission
			(
				netMgr.getcontrol() --takes queue control
				netMgr.wantControl=true --if another client does QueryControl(), they will get a return value of false
				netMgr.Lock true  --this completely prevents others from getting queue control
				netMgr.Lock false  --others can now get control
				
				job=netMgr.newJob file:fileSeedB0
				job.suspended = bbSuspended
				job.includemaps=true
				job.submit()
				job=netMgr.newJob file:fileSeedB1
				job.suspended = bbSuspended	
				job.includemaps=true
				job.submit()
			)
		)
	)
	
	fn init =
	(
		renderSceneDialog.commit()
-- 		rendBaseName = ""
		rendPassOne = ""
		rendPassTwo = ""
		rendResult = ""
		reFilePaths = #()

		altusCommandString = ""				--will contain the Altus command string to put in a batch file
		fileNamesArray=#()					--will contain the GENERATED RE names PER ALTUS ANIM RANGE (start frame of the range as number?)
		altusNamesArray=#()					--will contain the GENERATED RE names for the WHOLE SET of ALTUS ANIM RANGES (start frame of the range as number?)
		animationPickupFrames=#()			--will contain the rendPickupFrames string result (1,3,5-12)
		expandedAnimationFrames=#()			--Will contain the expanded list of frame numbers, across the whole animation range (for rendering purposes), like #(1,3,5,6,7,8,9,10,11,12)
		altusAnimRanges=#()					--Will contain sub-arrays of start and end frames, like #(#(1,1),#(3,3),#(5,12))
	)

	fn padToNDigits numDigits inString=
	(
		inString = inString as string --safety net.
		for i = 1 to (numDigits-inString.count) do
		(
			inString="0"+inString
		)
		inString
	)

	fn cleanREs =
		(
			re = maxOps.GetCurRenderElementMgr()
			elemBaseNamesList=#("AltusVrayDiffuseFilter", "AltusVrayMatteShadow", "AltusVrayBumpNormals","AltusVrayPointPosition","AltusVrayCaustics")
			for n = (re.numrenderelements()- 1) to 0 by -1 do
			(
				el = re.getrenderelement n
				for pat in elemBaseNamesList do 
				(
					if matchpattern el.elementname pattern:pat do 
					(
						re.RemoveRenderElement el
					)
				)
			)
		)
		
	fn addREs =
		(
			re=maxOps.GetCurRenderElementMgr() 
			elemList = #( VrayDiffuseFilter, VrayMatteShadow, VrayBumpNormals,VraySamplerInfo,VrayCaustics)
			elemBaseNamesList=#("AltusVrayDiffuseFilter", "AltusVrayMatteShadow", "AltusVrayBumpNormals","AltusVrayPointPosition","AltusVrayCaustics")
			for r=1 to elemList.count do 
			(
				theElement = (elemList[r]) elementName:elemBaseNamesList[r]
				re.AddRenderElement theElement 
			)
		)
		
	fn setBmpOut basePath imgNum =
	(
		cr.output_splitgbuffer=true
		case imgNum of				-- 0 is the base image path, the one visible to the user, 1 and 2 are the passes, used by the script, 3 is the output altus image, to be used forming the dos command string
		(
			0:										--set BASE output (visible to user)
			(
				rendBaseName=basePath
				cr.output_splitfilename=rendBaseName
				tempBmp=bitmap 1 1 hdr:on filename:rendBaseName
				save tempBmp
				cr.output_splitbitmap=tempBmp
				free tempBmp 
				deleteFile rendBaseName
				rendBaseName
			)
			1:								--set PASS output (invisible to user: passes 1 and 2)
			(
				rendPassOne=(getFilenamePath basePath)+(getFilenameFile basePath)+"_b"+(imgNum-1) as string+(getFilenametype basePath)
				cr.output_splitfilename=rendPassOne
				tempBmp=bitmap 1 1 hdr:on filename:rendPassOne
				save tempBmp
				cr.output_splitbitmap=tempBmp
				free tempBmp 
				deleteFile rendPassOne
				rendPassOne
			)
			2:								--set PASS output (invisible to user: passes 1 and 2)
			(
				rendPassTwo =(getFilenamePath basePath)+(getFilenameFile basePath)+"_b"+(imgNum-1) as string+(getFilenametype basePath)
				cr.output_splitfilename=rendPassTwo 
				tempBmp=bitmap 1 1 hdr:on filename:rendPassTwo 
				save tempBmp
				cr.output_splitbitmap=tempBmp
				free tempBmp 
				deleteFile rendPassTwo
				rendPassTwo
			)			
			3:
			(
				rendResult=(getFilenamePath basePath)+(getFilenameFile basePath)+"_Altus"+(getFilenametype basePath) 
			)
		)
	)
	
	fn gatherAnimationData =
	(

		altusAnimRanges=#()
		expandedAnimationFrames=#()
		case rendTimeType of
		(
			1:
			(
				expandedAnimationFrames[1]=sliderTime.frame as integer
-- 				print expandedAnimationFrames[1]
				altusAnimRanges[1]=#(expandedAnimationFrames[1],expandedAnimationFrames[1])
				isAnimatedSequence=False
			)
			2:
			(
				start=(animationRange.start as integer)
				end=(animationRange.end as integer)
				nth=(rendNThFrame as integer)
				base=rendFileNumberBase as integer
				for i = start to end do
				(
					append expandedAnimationFrames i
				)
				altusAnimRanges[1]=#(start+base,end+base)
				isAnimatedSequence=True
			)
			3:
			(
				start=(rendStart.frame as integer)
				end=(rendEnd.frame as integer)
				nth=rendNThFrame as integer
				base=rendFileNumberBase as integer
				for i = start to end do
				(
					append expandedAnimationFrames i
					
				)
				altusAnimRanges[1]=#(start+base,end+base)
				isAnimatedSequence=true
				
			)
			4:
			(
				animationPickupFrames= filterstring rendPickupFrames ","
				for f=1 to animationPickupFrames.count do
					(
						stringArray=filterstring animationPickupFrames[f] "-"
						if stringArray.count == 1 then
						(
							append expandedAnimationFrames (stringArray[1] as integer)
							append altusAnimRanges #((stringArray[1] as integer),(stringArray[1] as integer))
						)
						else
						(
							for i=(stringArray[1] as integer) to (stringArray[2] as integer) do
							(
								append expandedAnimationFrames i
							)
							append altusAnimRanges #((stringArray[1] as integer),(stringArray[2] as integer))
						)
					)
				isAnimatedSequence=True
			)
		)
		expandedAnimationFrames
	)	

	fn setREfilePaths =
	(
		-- output of type baseimage.reName.frame[0000].ext

		elemBaseNamesList=#("RGB_color","AltusVrayDiffuseFilter", "AltusVrayMatteShadow", "AltusVrayBumpNormals","AltusVrayPointPosition","AltusVrayCaustics")
		altusNamesArray=#()
-- 		print "isAnimatedSequence"
-- 		print isAnimatedSequence
		if not isAnimatedSequence then
		(

			for passNum = 1 to 2 do
			(			
				for el in elemBaseNamesList do
				(
					backSlashString=""
-- 					print (padToNDigits 4 altusAnimRanges[1][1])
					if rendTimeType == 2 or rendTimeType == 3 then 
					(
						backSlashString = ((getFilenamePath rendBaseName)+(getFilenameFile rendBaseName)+"_b"+((passNum-1) as string)+"."+el+"."+(padToNDigits 4 (altusAnimRanges[1][1]))+(getFilenametype rendBaseName))
					)
					else
					(
						backSlashString = ((getFilenamePath rendBaseName)+(getFilenameFile rendBaseName)+"_b"+((passNum-1) as string)+"."+el+"."+(padToNDigits 4 altusAnimRanges[1][1])+(getFilenametype rendBaseName))
					)
						
		-- 			fwdSlashString = substituteString backSlashString @"\" @"/"
					append fileNamesArray backSlashString
				)
				append altusNamesArray fileNamesArray
			)
			
		)
		else
		(
			for r=1 to altusAnimRanges.count do
			(
				for passNum = 1 to 2 do
				(			
					for el in elemBaseNamesList do
					(
						backSlashString=""
-- 						print (padToNDigits 4 altusAnimRanges[r][1])
						if rendTimeType == 2 or rendTimeType == 3 then 
						(
							backSlashString = ((getFilenameFile rendBaseName)+"_b"+((passNum-1) as string)+"."+el+(getFilenametype rendBaseName))
						)
						else
						(
							backSlashString = ((getFilenameFile rendBaseName)+"_b"+((passNum-1) as string)+"."+el+(getFilenametype rendBaseName))
						)
							
			-- 			fwdSlashString = substituteString backSlashString @"\" @"/"
						append fileNamesArray backSlashString
					)
					append altusNamesArray fileNamesArray
				)
			)
		)

		altusNamesArray
	)

	fn buildAltusCommandString =
	(
-- 		print "BUILDING Altus CMD String"
-- 		print altusAnimRanges[1]
		batchOut=#()
			
		
		for r=1 to altusAnimRanges.count do
		(
			-- 			print altusNamesArray[r][1+((r-1)*12)]
			altusCommandString="altus.exe "																		--main executable file. the path to its folder is in the system path variable.
			altusCommandString+=("-i \"" + (getfilenamefile (setBmpOut rendBaseName 3)) + "\" ")				--Denoised Result file NAME
			altusCommandString+=("-o \"" + (substring (getfilenamePath rendResult) 1 ((getfilenamePath rendResult).count-1)) + "\" ")									--Denoised Result file PATH
			-- AltusNamesArray is of the form #(#(path,path,path,path...12),#(path, path, path, path...12)X altusAnimRanges Count)
			altusCommandString+=("-b \"" + altusNamesArray[r][1+((r-1)*12)] + "\" ") + ("-b \"" + altusNamesArray[r][1+6+((r-1)*12)] + "\" ")		--First and Second BEAUTY passes ("RGB Color")
			altusCommandString+=("-a \"" + altusNamesArray[r][2+((r-1)*12)] + "\" ") + ("-a \"" + altusNamesArray[r][2+6+((r-1)*12)] + "\" ")		--First and Second ALBEDO passes ("Diffuse Filter")
			altusCommandString+=("-v \"" + altusNamesArray[r][3+((r-1)*12)] + "\" ") + ("-v \"" + altusNamesArray[r][3+6+((r-1)*12)] + "\" ")		--First and Second DIRECT LIGHT VISIBILITY passes ("Matte Shadow")
			altusCommandString+=("-n \"" + altusNamesArray[r][4+((r-1)*12)] + "\" ") + ("-n \"" + altusNamesArray[r][4+6+((r-1)*12)] + "\" ")		--First and Second NORMAL passes ("Bump Normal")
			altusCommandString+=("-p \"" + altusNamesArray[r][5+((r-1)*12)] + "\" ") + ("-p \"" + altusNamesArray[r][5+6+((r-1)*12)] + "\" ")		--First and Second WORLD POSITION passes ("Point Position World")
			altusCommandString+=("-c \"" + altusNamesArray[r][6+((r-1)*12)] + "\" ") + ("-c \"" + altusNamesArray[r][6+6+((r-1)*12)] + "\" ")		--First and Second NORMAL passes ("Bump Normal")				
			if isAnimatedSequence then		--Not only it needs the flags, the images need NO PATH!
			(				
				altusCommandString+=("-s " + (padToNDigits 4 altusAnimRanges[r][1]) + " -e " + (padToNDigits 4 altusAnimRanges[r][2]) + " ")
				altusCommandString+=("-f " + (filterFrames as string) + " ")	
			)

			if useGPU do 
			(
				altusCommandString+=("-g ")
			)
			altusCommandString+=("-r " + (filterRadius as string) + " ")
			if rendTimeType == 2 or rendTimeType == 3 then 
			(
				append batchOut ((getfilenamePath rendResult) + (getfilenameFile rendResult) + "_AltusProcess."+(padToNDigits 4 (altusAnimRanges[r][1]))+".bat")
			)
			else
			(
				append batchOut ((getfilenamePath rendResult) + (getfilenameFile rendResult) + "_AltusProcess."+(padToNDigits 4 altusAnimRanges[r][1])+".bat")
			)		

			theBatch=openFile batchOut[r] mode:"w"
			format (altusCommandString+"\npause") to:theBatch
			close theBatch
-- 			print batchOut[r]

		)
		batchOut
	)
	
	fn feedTheBeast =
	(
		
		/*
		The main function here does a few things in order:
		these are done regardless of other options:
			Clean and re-set REs (options for those?)
			Gather all the Scene Data (anim ranges and such)
			Set the base render output filename(so to be able to feed the other functions with meaningful data)
		These produce different values (as in array contents) depending on options
			set up the Altus RE file names for pass 1 and 2, this is done per altus anim range
			Build and save the Altus command file, per anim range.
			IF it's an animated sequence, the command gets appended start and end frames, otherwise it's a single frame.
		Finally render the sequence (or save the max files, or submit to BB)
		If wanted, run the altus command file(s)
		*/
		renderSceneDialog.close()
		macros.run "Render" "RenderButtonMenu_Switch_To_Production_Mode"
		renderSceneDialog.commit()
		renderSceneDialog.open()
		if keyboard.escPressed do 
		(exit with restoreOldSplitData())
		init()
-- 		print "init"
		cleanREs()
-- 		print "cleanREs"
		addREs()
-- 		print "addREs"
		gatherAnimationData()
-- 		print "gatherAnimationData"
		setBmpOut rendBaseName 0
-- 		print "set basename"

		if doSaveSeeded then --just set up the scenes, and Altus commands, and save it all out (for manual or BB use)
		(
-- 			print "dosaveseeded"
			setREfilePaths() 			--fill the name array of render element file paths for pass 1 (will generate the 6 names) and put them into fileNamesArray[1-6]
-- 			setREfilePaths 2		--fill the name array of render element file paths for pass 2 (will generate the 6 names) and put them into fileNamesArray[7-12]
			batchOut=buildAltusCommandString()		--always returns an array of command file paths
			
			for b in batchOut do
			(
				copyBatch= (maxFilePath+(getFilenameFile b)+".bat")		
				renameFile b copyBatch	
			)				
			
			setBmpOut rendBaseName 1  	--Pass 1 outputs set up			
			cr.dmc_randomSeed=0			--assign it
			fileSeedB0=(maxFilePath+(getfilenamefile maxfilename)+"_b0"+".max")
			saveMaxFile fileSeedB0 clearNeedSaveFlag:false useNewFile:false	

			setBmpOut rendBaseName 2  	--Pass 2outputs set up		
			cr.dmc_randomSeed=12340			--assign it		s
			fileSeedB1=(maxFilePath+(getfilenamefile maxfilename)+"_b1"+".max")
			saveMaxFile fileSeedB1 clearNeedSaveFlag:false useNewFile:false

			cleanREs()
			restoreOldSplitData()
		)
		
		else
		(
			setREfilePaths() 			--fill the name array of render element file paths for pass 1 (will generate the 6 names) and put them into fileNamesArray[1-6]
			batchOut=buildAltusCommandString()		--always returns an array of command file paths
			print batchOut
			setBmpOut rendBaseName 1  	--Pass 1 outputs set up			
			cr.dmc_randomSeed=0			--set seed to 0
-- 			max quick render 
			for r in AltusAnimRanges do
			(
				frameRange=(interval r[1] r[2])
				render vfb:off frameRange:frameRange
			)
-- 			for f in expandedAnimationFrames do
-- 			(
-- 				slidertime=f
-- 				frameRange=
-- 				render vfb:off							--render the first pass
-- 			)

			setBmpOut rendBaseName 2  	--Pass 2outputs set up		
			cr.dmc_randomSeed=12340			--set seed to 12340
			for r in AltusAnimRanges do
			(
				frameRange=(interval r[1] r[2])
				render vfb:off frameRange:frameRange
			)
-- 			for f in expandedAnimationFrames do
-- 			(
-- 				slidertime=f
-- 				render vfb:off							--render the second pass
-- 			)
-- 			max quick render
-- 			setBmpOut rendBaseName 0
			cleanREs()	
			restoreOldSplitData()
			
-- 			for r in altusNamesArray do
-- 			(
-- 				for f in r do
-- 					(
-- 						if not (doesfileexist f) then
-- 						(
-- 							exit with messageBox "Oh-oh!\nFiles are missing!"
-- 						)
-- 						else print "pass checks out on disk, ready to go!"
-- 					)
-- 			)
			
			-- generate the Altus Output and execute it
			for b in batchOut do
			(
				vrayShellLaunch b	
			)	

		)
		

		if doBB do
		(
			submitToBB()
		)
	)
	
	fn setEdtBox = 
	(
		if cr.output_splitfilename == undefined or cr.output_splitfilename == "" then
		(
			altusRoll.outEdt.text="Please Browse to Set a base filename output"
			rendBaseName=""
			altusRoll.goBtn.enabled=altusRoll.opnBtn.enabled=false
		)
		else
		(
			altusRoll.outEdt.text=cr.output_splitfilename
			rendBaseName=cr.output_splitfilename
			altusRoll.goBtn.enabled=altusRoll.opnBtn.enabled=true
		)
		rendBaseName
	)

	fn fillInfoBox =
	(
		theString=""
		theString+=("")
	)	
	
	rollout altusRoll "Altus Denoiser Sample GUI v. 0.12" width:504 height:184
	(
			
		GroupBox 'grp1' "Config:" pos:[8,8] width:488 height:68 align:#left 
 
		label 'tmpLbl' "Base filename:" pos:[16,32] width:72 height:16 align:#left 
 
		button 'outBtn' "Browse..." pos:[88,32] width:64 height:16 align:#left 	tooltip:"Browse for the BASE filename for split file output"
 	
		edittext 'outEdt' "" pos:[152,32] width:320 height:16 enabled:false align:#left tooltip:"Displays the selected base file name and path"
		button 'opnBtn' "O" pos:[476,32] width:16 height:16 enabled:false align:#left tooltip:"Open the Output Folder in Explorer"
		checkbox 'seedChk' "Checkbox" pos:[16,56] width:16 height:16 align:#left tooltip:"Check this to just create and save out the Max pass files, and the batch file for Altus (it won't render for you.).\nThe Altus Bat File is moved to the MAX FILES' FOLDER"
		label 'seedLbl' "Save Seeded Max Files" pos:[32,56] width:112 height:16 align:#left
		checkbox 'bbChk' "Checkbox" pos:[152,56] width:16 height:16 align:#left tooltip:"Check this to submit the two pass files to BackBurner.\nThe Altus Bat File is moved to the MAX FILES' FOLDER"
		label 'bbLbl' "Submit to BackBurner" pos:[168,56] width:104 height:16 align:#left 
		checkbox 'suspChk' "Checkbox" pos:[280,56] width:16 height:16 enabled:false checked:true align:#left tooltip:"Check this to submit to BackBurner in suspended mode."
		label 'suspLbl' "Submit Suspended" pos:[296,56] width:104 height:16 enabled:false align:#left	
	
		GroupBox 'grp2' "Altus Processing Options" pos:[8,80] width:488 height:48 align:#left
		label 'fltLbl' "Filter Radius:" pos:[16,104] width:64 height:16 align:#left
		spinner 'fltSpn' "" pos:[88,104] width:56 height:16 range:[1,100,10] type:#integer scale:1 align:#left tooltip:"Altus Filter Radius"
		label 'fltFLbl' "Filter Frames:" pos:[152,104] width:72 height:16 align:#left
		spinner 'fltFSpn' "" pos:[232,104] width:56 height:16 range:[1,100,1] type:#integer scale:1 align:#left	toolTip:"Altus Frames Filter Range"
		checkbox 'gpuChk' "Checkbox" pos:[296,104] width:16 height:16 checked:true align:#left tooltip:"Should Altus use the GPU? (Try either option should you get crashes.)"
		label 'gpuLbl' "Use GPU" pos:[312,104] width:48 height:16 align:#left 
		
		button 'goBtn' "Render To Altus Denoiser" pos:[8,136] width:488 height:40 enabled:false align:#left tooltip:"Let the process begin!\nCheck the output folder for progress, if you decide to render within the current max session!"
	
		



		
		

		on altusRoll open do
		(
			readOldSplitData()
			init()
			setEdtBox()
		)
		
		on outBtn pressed do
		(
			try 
			(
				rendBaseName=getSaveFileName caption:"Choose the BASE filename for your output:" filename:"*.exr" types:"OpenEXR(*.exr)|*.exr"
				setBmpOut rendBaseName 0
				setEdtBox()
			)
			catch 
			(
				setEdtBox()
			)
		)
		
-- 		on outEdt entered txt do
-- 		(
-- 			rendBaseName=txt
-- 			setBmpOut rendBaseName 0
-- 			makeDir (getfilenamepath  rendBaseName)
-- 			setEdtBox()
-- 		)
		
		on opnBtn pressed do
		(
			try 
			(
				makeDir (getfilenamepath  rendBaseName)
				shellLaunch "explorer.exe" (getfilenamepath rendBaseName)
			) 
			catch()
		)
		
		on seedChk changed state do
		(
			doSaveSeeded = state
			isAnimatedSequence = not state
		)
		
		on bbChk changed state do
		(
			seedChk.checked=doSaveSeeded=doBB=suspChk.enabled=suspLbl.enabled=state
-- 			print doSaveSeeded
			seedChk.enabled=seedLbl.enabled=isAnimatedSequence=not state
			
		)
		
		on suspChk changed state do
		(
			bbSuspended=state
		)
		
		on fltSpn changed val do
		(
			filterRadius = val
		)
		
		on gpuChk changed state do
		(
			useGPU=state
		)
		
		on fltFSpn changed val do
		(
			filterFrames = val
		)		
		
		on goBtn pressed do
		(
			feedTheBeast()
		)

	)
	
	createDialog altusRoll
)




